/*
 * vim: ts=4 nobackup
 */


#include <stdlib.h>
#include "Game.H"


using namespace std;
using namespace avelino;


void Game::init(GamePlayer &p1, GamePlayer &p2, GameBoard &board) {
	this->player[0] = &p1;
	this->player[1] = &p2;
	this->board = &board;
	this->playerIndex = 0;
	this->winner = NULL;
}


void Game::run() {
	bool playerMoved = false;
	GamePlayer *p = this->player[this->playerIndex];
	p->run(playerMoved);
	if (playerMoved) {
		if (p->isWinner())
			this->winner = p;
		else
			this->playerIndex = 1 - this->playerIndex;
	}
}


bool Game::isFinished() {
	return (this->board->isFinished() || (this->winner != NULL));
}


GamePlayer *Game::getWinner() {
	return this->winner;
}


