/*
 * vim: ts=4 nobackup
 */


#include <avr/io.h>
#include <stdint.h>
#include "MyLedMatrixManager.H"


using namespace avelino;
using namespace std;


MyLedMatrixManager::MyLedMatrixManager() : LedMatrixManager(3, 3) {
	this->clear();
}


uint8_t MyLedMatrixManager::getDot(uint8_t x, uint8_t y) {
	return this->dots[x][y];
}


void MyLedMatrixManager::configurePorts() {
	DDRD |= 0x1F;
	DDRC |= 0x40;
}


void MyLedMatrixManager::setRow(uint8_t row, bool v) {
	if (v) {
		if (row == 0)
			PORTD |= 0x01;
		else if (row == 1)
			PORTD |= 0x10;
		else if (row == 2)
			PORTC |= 0x40;
	}
	else {
		if (row == 0)
			PORTD &= (uint8_t) ~0x01;
		else if (row == 1)
			PORTD &= (uint8_t) ~0x10;
		else if (row == 2)
			PORTC &= (uint8_t) ~0x40;
	}
}


void MyLedMatrixManager::setColumn(uint8_t column, bool v) {
	if (v) {
		if (column == 0)
			PORTD &= (uint8_t) ~0x04;
		else if (column == 1)
			PORTD &= (uint8_t) ~0x08;
		else if (column == 2)
			PORTD &= (uint8_t) ~0x02;
	}
	else {
		if (column == 0)
			PORTD |= 0x04;
		else if (column == 1)
			PORTD |= 0x08;
		else if (column == 2)
			PORTD |= 0x02;
	}
}


void MyLedMatrixManager::clear() {
	for (uint8_t y = 0; y < 3; y++) {
		for (uint8_t x = 0; x < 3; x++)
			this->dots[x][y] = 0;
	}
}


