/*
 * vim: ts=4 nobackup
 */


#include "util.H"
#include "Timer.H"
#include "MyLedMatrixManager.H"
#include "MyKeyMatrixManager.H"
#include "TTTRandomGamePlayer.H"
#include "Game.H"
#include "TTTHumanGamePlayer.H"
#include "TTTLedGameBoard.H"


using namespace std;
using namespace avelino;


#define  GAME_STATUS_PLAYING   1
#define  GAME_STATUS_FINISHED  2


MyLedMatrixManager ledMatrixManager;
MyKeyMatrixManager keyMatrixManager;
TTTRandomGamePlayer p1;
TTTHumanGamePlayer p2;
Game g;
TTTLedGameBoard board;
uint8_t gameStatus;


int main() {
	Timer::init();
	ledMatrixManager.init();
	board.init(ledMatrixManager);
	p1.init(1, board);
	p2.init(2, board);
	keyMatrixManager.init(p2);
	g.init(p1, p2, board);
	gameStatus = GAME_STATUS_PLAYING;
	while (true) {
		ledMatrixManager.run();
		if (gameStatus == GAME_STATUS_PLAYING) {
			if (!g.isFinished()) {
				keyMatrixManager.run();
				g.run();
				board.show();
			}
			else
				gameStatus = GAME_STATUS_FINISHED;
		}
		else if (gameStatus == GAME_STATUS_FINISHED) {
			//
		}
	}
	return 0;
}
